{
  hlavni knihovna funkci pro praci s CWG;
  - funkce polecne vsem zalozkam
  - funkce pro praci s oficialnim/maxinohovym katalogem a jejich offline zalohou
}

var  fButChooseAktOnClick:TfEventProcedure;

function DecodeCwgInfo(row:string;skip:integer):TCwgInfo; //separuje informace z radku z katalogu
begin
  Result.UpAsciiNick:=''; Result.Nick:=''; Result.Guid:='';
  Result.ImgUrl:=''; Result.ImgNum:='';
  Result.GcId:=''; Result.Katalog:='';
  if(skip<=0) then Result.UpAsciiNick:=fetch(row,'|');
  if(skip<=1) then Result.Nick:=fetch(row,'|');
  if(skip<=2) then Result.Guid:=fetch(row,'|');
  if(skip<=3) then Result.ImgUrl:=fetch(row,'|');
  if(skip<=4) then Result.ImgNum:=fetch(row,'|');
  if(skip<=5) then Result.GcId:=fetch(row,'|');
  if(skip<=6) then Result.Katalog:=fetch(row,'|');
end;

procedure ReadKatalog(list:TListBox;bKatalog:boolean); //nacte vsechna CWG z ulozeneho katalogu
var s,radek:string;
  info:TCwgInfo;
  i:integer;
begin
  list.Clear();
  if(FileExists(sFileKatalog)) then begin
    s:=FileToString(sFileKatalog); //pouzijeme zalohu katalogu
    s:=UtfToAnsi(s);
    sKatalog:=ReplaceString(s,CRLF,'');
    s:=sKatalog;
    i:=0;
    CwgForm_butCwgChoose.Cursor:=crHourglass;
    while(s<>'') do begin
      i:=i+1;
      radek:=fetch(s,'');
      info:=DecodeCwgInfo(radek,0);
      if(info.Nick<>'') then begin
        radek:=info.Nick;
        if(bKatalog) then radek:=radek+'  | '+info.Katalog;
        list.Items.Add(radek);
      end;
    end;
    CwgForm_butCwgChoose.Cursor:=crDefault;
  end;
  //ShowMessage('XXXX nacteno '+IntToStr(i)+' CWG');
  if(list.Items.Count=0) then begin
    //ShowMessage('Neexistuje offline zaloha katalogu CWG:'+CRLF+sFIleKatalog+CRLF+CRLF
    //  +'Pouijte tlatko "Nov seznam" v dialogu vyvolanm na'+CRLF
    //  +'kart "CWG v kech" pes tlatko "...".');
    if(6=MessBox('Neexistuje offline zaloha katalogu CWG:'+CRLF+sFileKatalog+CRLF+CRLF
      +'Nast katalog?', 'Varovn',4 {tj. Ano/ne, odpoved 6=Ano})) then begin
      fButChooseAktOnClick(nil);
      ReadKatalog(CwgForm_lFileKat,false);
    end;
  end;
end;

function GetCwgInfo(name:string):string; //nacte informace o CWG
begin
  Result:='';
  if(name<>'') then begin
    Result:=fetch(sKatalog,'|'+name+'|');
    Result:=fetch(Result,''); //az do konce radky
  end;
end;

procedure butCwgChooseOnClick(sender:TObject);
begin
  ReadKatalog(CwgCtlg_lChooseName,CwgCtlg_bChooseCatalog.Checked);
  CwgCtlg_sChooseNumKatalog.Caption:=IntToStr(CwgCtlg_lChooseName.Items.Count)+'  CWG';
  CwgCtlg_tChooseName.caption:=CwgForm_ID.caption;
  if(sender=CwgForm_butCwgChoose) then CwgCtlg.ShowModal;
end;

procedure lChooseNameOnClick(sender:TObject);
var b,bList,bZmKat:boolean;
    s,s1,name,jpg,ver:string;
    info:TCwgInfo;
    list:TListbox;
begin
  if(bSemafor=false) then begin
    bSemafor:=true;
    bList:=false;
    bZmKat:=false;
    list:=TListbox(sender);
    if((sender=CwgForm_lFileKat) or (sender=CwgForm_lFileFile)
      or (sender=CwgCtlg_lChooseName)) then bList:=true;
    //nacteme obrazek z webu a zobrazime ho
    if(bList) then begin
      b:=false;
      if((sender=CwgCtlg_lChooseName) and (CwgCtlg_bChooseView.Checked)) then b:=true;
      if((sender<>CwgCtlg_lChooseName) and (CwgForm_bFileView.Checked)) then b:=true;
      if(b) then begin
        //zmenime kurzor na hodiny
        list.Cursor:=crHourglass;
        //zjistime obrazek a adresu podle katalogu
        if(list.ItemIndex<0) then s:=''
        else s:=list.Items[list.ItemIndex];
        ver:=RegexReplace('.*<.*VER="([0-9]*)".*',s,'$1',true);
        if(ver=s) then ver:='' else ver:=' (<VER="'+ver+'"/>)';
        //oddelime pripadne doplnkove informace o CWG (lFilelFile) a informaci o katalogu (lFileKat)
        s1:=fetch(s,'(<');
        name:=Trim(fetch(s1,'|'));
        s1:='|'+name+ver+'|';   //hledany string v katalogu
        jpg:=sKatalog;      //aby fetch neprepsalo nacteny katalog
        fetch(jpg,s1);      //v jpg nechame jen radek s hledanym CWG
        s:=fetch(jpg,'');  //radek s timto CWG (odriznutim konce)
        jpg:=name+'|'+name+ver+'|'+s; //zkonstruujeme cely radek radek
        info:=DecodeCwgInfo(jpg,0);   //nacteme informace o CWG
        //jmeno souboru, pod kterym si CWG ulozime do offline adresare
        s1:=RegexReplace('^.*/',info.ImgUrl,'',true);      //jen jmeno souboru
        if(s1='') then s1:=sDirOffline+'CwgMissing.jpg'
        else s1:=sDirOffline+s1;
        b:=false;
        if((not FileExists(s1)) or (CwgCtlg_bChooseRefresh.Checked))then begin
          //while((not b)) do begin
            if(info.Katalog='O') then s:='http://www.gc-plzen.net/_images/cwg/cwg/'+info.ImgUrl
            else if(info.Katalog='M') then s:='http://cwg.maxinoha.cz/img/'+info.ImgUrl
            //28.5.2012 zmena serveru
            //else if(info.Katalog='S') then s:='http://img.cwg.cc/'+info.ImgUrl
            else if(info.Katalog='S') then s:='http://img.tftc.eu/'+info.ImgUrl
            else s:='http://gord.gringo.cz/Geocaching/Img/CwgMissing.jpg';
            //ShowMessage('OOOOO s='+s+CRLF+'img:='+s1);
            jpg:='';
            b:=HttpAsk('GET',s,'image/jpeg', '', jpg);
            //ShowMessage('OOOOO-1 delka obrazku: '+IntToStr(length(jpg)));
            if(not b) then ShowMessage('Chyba stazeni obrazku s CWG.')
            else StringToFile(jpg,s1);
            //kontrola, zda byl opravdu obrazek stazen (kontrolujeme zacatek hlavicky JPG)
            {
            if((Char(0xFF)+Char(0xD8)+Char(0xFF)+Char(0xE0)+Char(0x00)
              +Char(0x10)+Char(0x4A)+Char(0x46)+Char(0x49)_Car(0x46))
              <>copy(jpg,1,10)) then b:=false;
            if(b) then StringToFile(jpg,s1)
            else begin
              if(info.Katalog='O') then
                begin bZmKat:=true; info.Katalog='M'; end  //zkusime maxinohuv katalog
              else begin
                if(info.Katalog='M') then
                  begin bZmKat:=true; info.Katalog='X'; end //nacteme Missing obrazek
                else begin //nenacetli jsme ani vlastni obrazek 'Missing'
                  ShowMessage('Chyba stazeni obrazku s CWG.');
                  b:=true;   //aby se vzdycky alespon nejak skoncilo
                  bZmKat:=true;
                end;
              end;
            end;
            }
          //end;  //while
        end;
        if(bZmKat) then begin //musime zmenu katalogu promitnout do souboru
        end;
        if(list=CwgCtlg_lChooseName) then CwgCtlg_bChooseImg.Picture.LoadFromFile(s1)
        else CwgForm_imgFileCwg.Picture.LoadFromFile(s1);
        //vratime kurzor zpet
        list.Cursor:=crDefault;
      end;
    end;
    bSemafor:=false;
  end;
end;

procedure bChooseViewOnClick(sender:TObject);
begin
  CwgCtlg_bChooseImg.Visible:=CwgCtlg_bChooseView.Checked;
  lChooseNameOnClick(CwgCtlg_lChooseName);
end;

procedure butChooseAktOnClick(sender:TObject); //aktualizace seznamu CWG novym nactenim ze serveru
var s:string;
    i:integer;
begin
  s:=DoplnUvozovky(GEOGET_SCRIPTDIR+'\CwgList\GgsCwgList.exe')+' -r '+DoplnUvozovky(sFileKatalog);
  if(FileExists(GEOGET_SCRIPTDIR+'\CwgList\GgsCwgList.exe')) then i:=RunExec(s)
  else ShowMessage('Nenalezen plugin '+GEOGET_SCRIPTDIR+'\CwgList\GgsCwgList.exe');
  //ShowMessage('Pred on click');
  if(sender<>nil) then butCwgChooseOnClick(nil);
  //ShowMessage('Za on click');
end;

procedure bChooseCatalogOnClick(sender:TObject);
begin
  ReadKatalog(CwgCtlg_lChooseName,CwgCtlg_bChooseCatalog.Checked);
  CwgCtlg_sChooseNumKatalog.Caption:=IntToStr(CwgCtlg_lChooseName.Items.Count)+'  CWG';
end;

procedure butChooseAddOnClick(sender:TObject);
var s:string;
begin
  if(CwgCtlg_lChooseName.ItemIndex>-1) then begin
    s:=CwgCtlg_lChooseName.Items[CwgCtlg_lChooseName.ItemIndex];
    CwgForm_eNick.Text:=Trim(fetch(s,'|'));
    //s:=RegexReplace('(.*<VER=")([0-9]*)("\s*/\s*>.*)$',CwgCtlg_lChooseName.Items[CwgCtlg_lChooseName.ItemIndex],'$2',true);
    //if(s=CwgCtlg_lChooseName.Items[CwgCtlg_lChooseName.ItemIndex]) then CwgForm_eVerze.Text:=''
    //else CwgForm_eVerze.Text:=s;
    CwgForm_eVerze.Text:=StructStringGetValue(
      'VER',CwgCtlg_lChooseName.Items[CwgCtlg_lChooseName.ItemIndex]);
    fOnChange(nil);
  end;
end;

procedure butChooseCancelOnClick(sender:TObject);
begin
  //CwgForm_pChooseCwg.Visible:=false; //zobrazime panel se seznamem
end;

procedure butChooseClearOnClick(sender:TObject);
begin
  //ShowMessage('Mazu: '+sDirOffline+'\'+'*.jpg');
  DeleteFiles(sDirOffline+'\'+'*.jpg');
  ShowMessage('Adresar vyitn.');
end;

procedure ChooseCwgOnKeyDown(sender:TObject;var Key: Word; Shift: TShiftState);
begin
  if(Key=27) then butChooseCancelOnClick(nil);
  if((Key=13) and (sender=CwgCtlg_lChooseName)) then butChooseAddOnClick(nil);
end;

procedure InitFormCtlg;
begin
  fButChooseAktOnClick:=@butChooseAktOnClick;
  //formular pro vyber CWG ze seznamu podle katalogu
  CwgCtlg_butChooseAdd.onClick:=@butChooseAddOnClick;
  CwgCtlg_butChooseCancel.onClick:=@butChooseCancelOnClick;
  CwgCtlg_butChooseAkt.onClick:=@butChooseAktOnClick;
  CwgCtlg_bChooseCatalog.onClick:=@bChooseCatalogOnClick;
  CwgCtlg_lChooseName.onClick:=@lChooseNameOnClick;
  CwgCtlg_bChooseView.onClick:=@bChooseViewOnClick;
  CwgCtlg_butChooseClear.onClick:=@butChooseClearOnClick;
  //obsluha klavesy ESC pro zruseni dialogu s vyberem CWG z katalogu
  {
  CwgCtlg_lChooseName.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_bChooseView.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_bChooseRefresh.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_bChooseCatalog.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_butChooseAkt.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_butChooseAdd.onKeyDown:=@ChooseCwgOnKeyDown;
  CwgCtlg_butChooseCancel.onKeyDown:=@ChooseCwgOnKeyDown;
  }
  bChooseViewOnClick(nil);
end;
