{
  funkce pracujici se zalozkou pro vyhledani kesi podle CWG
}
procedure SetEnableButFind;
begin
  CwgForm_butAddCache.Enabled:=((CwgForm_lNalezene.SelCount>0) or (CwgForm_lNalezene.ItemIndex>=0));
  CwgForm_butCache.Enabled:=(CwgForm_lNalezene.ItemIndex>=0);
  CwgForm_butFind.Enabled:=(CwgForm_eFindCwg.text<>'');
end;

procedure OnChangeFind(sender:TObject);
begin
  SetEnableButFind();
end;

procedure butCacheOnClick(sender:TObject); //nastavi vyhledanou kes do seznamu
var s,s1:string;                           //a vyvola jeji editaci (zajisteno
    i:integer;                             //navratovou hodnotou 4)
begin
  ClearLibCaches();
  i:=CwgForm_lNalezene.ItemIndex;
  if(i>=0) then begin
    s:=CwgForm_lNalezene.Items[i];
    s1:=Trim(fetch(s,'-'));
    i:=AddLibCache(s1);
    aktCache:=i;
    SetActiveTab('TabTag');
  end;
end;

procedure butAddCacheOnClick(sender:TObject);
var i,j:integer;
  s,s1:string;
begin
  j:=-1;
  for i:=0 to CwgForm_lNalezene.Items.Count-1 do begin
    if(CwgForm_lNalezene.Selected[i]) then begin
      s:=CwgForm_lNalezene.Items[i];
      s1:=Trim(fetch(s,'-'));
      if(j<0) then j:=AddLibCache(s1)
      else AddLibCache(s1);
    end;
  end;
  if(j>=0) then begin
    aktCache:=j;
    GetListForCache();
    SetActiveTab('TabTag');
  end;
end;

procedure butAddGGOnClick(sender:TObject);
var i,j:integer;
  s,s1:string;
  g:TGeo; //geo je globalni, nemuzu ji ted pouzit
begin
  j:=-1;
  g:=TGeo.Create();
  for i:=0 to CwgForm_lNalezene.Items.Count-1 do begin
    if(CwgForm_lNalezene.Selected[i]) then begin
      s:=CwgForm_lNalezene.Items[i];
      s1:=Trim(fetch(s,'-'));
      g.LoadByGC(s1);
      g.ListAdd();
    end;
  end;
  g.Free;
end;

procedure butFindOnClick(sender:TObject);
var s,sutf,dotaz,dotaz1:string;
    //i:integer;
    tab: TSqliteTable;
begin
  dotaz1:='';
  sutf:=AnsiToUtf(CwgForm_eFindCwg.text);
  //vyhledavaci retez nastavime podle zaskrtnute volby pro vyhledavani
  if(CwgForm_Cmp.ItemIndex=0) then begin
    dotaz1:='(upper(gtv.value)=upper("'+sutf+'")'  //CWG bez doplnujicich informaci
      +' OR gtv.value LIKE "'+sutf+' (%")';        //CWG s doplnujicimi informacemi
  end;
  if(CwgForm_Cmp.ItemIndex=1) then dotaz1:='gtv.value LIKE "'+sutf+'%"';   //CWG bez doplnujicich informaci
  if(CwgForm_Cmp.ItemIndex=2) then dotaz1:='gtv.value LIKE "%'+sutf+'%"';  //CWG bez doplnujicich informaci
  if(CwgForm_Cmp.ItemIndex=3) then dotaz1:='gtv.value LIKE "'+sutf+'"';    //pro frazi Like
  //nacteme seznam vyhovujicich kesi
  CwgForm_lNalezene.Items.Clear();
  if(dotaz1<>'') then begin
    dotaz:='select gc.id,gc.name,gtv.value '
       +' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv '
       +'  WHERE gtc.value="'+TAG_CWG+'" and gtv.key=gt.ptrvalue and '
       +'  '+dotaz1+' and gt.id=gc.id and gtc.key=gt.ptrkat ';
    if(CwgForm_kde.ItemIndex=0) then dotaz:=dotaz+'  and gc.dtfound>0 ';
    dotaz:=dotaz+' ORDER BY gtv.value';
    //ShowMessage('GGGGG: '+dotaz);
    tab:=Geoget_DB.GetTable(dotaz,false);
    try
      while not tab.eof do begin
        s:=UtfToAnsi(tab.FieldAsString(0)+' - '+tab.FieldAsString(1)+': '+tab.FieldAsString(2));
        CwgForm_lNalezene.Items.Add(s);
        tab.next;                   // skok na dalsi
      end;
    finally tab.free;
    end;
  end;
  SetEnableButFind();
end;

procedure FindCwgOnKeyDown(sender:TObject;var Key: Word; Shift: TShiftState);
begin
  if(Key=13) then begin
    if(sender=CwgForm_eFindCwg) then butFindOnClick(nil);
  end;
end;

procedure InitFormFind;
begin
  //formular pro hledani
  CwgForm_butFind.onClick:=@butFindOnClick;
  CwgForm_butCache.onClick:=@butCacheOnClick;
  CwgForm_butAddCache.onClick:=@butAddCacheOnClick;
  CwgForm_butAddGG.onClick:=@butAddGGOnClick;
  CwgForm_lNalezene.onClick:=@OnChangeFind;
  CwgForm_eFindCwg.onChange:=@OnChangeFind;
    //obsluha klavesy ENTER
  CwgForm_eFindCwg.onKeyDown:=@FindCwgOnKeyDown;
  CwgForm_lNalezene.onKeyDown:=@FindCwgOnKeyDown;
end;
