{
  funkce pracujici se zalozkou CWG v alternativnim souboru
}
var bFileChangeCwg,bFileChangeNick,bFileChangeList:boolean;

procedure SetEnableButFile;
begin
  CwgForm_butFileAdd.Enabled:=(CwgForm_lFileKat.ItemIndex>=0);
  CwgForm_butFileDel.Enabled:=(CwgForm_lFileFile.ItemIndex>=0);
  CwgForm_butFileSave.Enabled:=bFileChangeList;
  CwgForm_butFileNew.Enabled:=bFileChangeNick;
  CwgForm_butFileZmenit.Enabled:=((bFileChangeCwg) and (CwgForm_lFileFile.ItemIndex>=0));
end;

procedure OnFileChange(sender:TObject);
begin
  if(sender=CwgForm_eFileNick) then bFileChangeNick:=true;
  bFileChangeCwg:=true;
  SetEnableButFile();
end;

procedure TagToFormFile; //naplni hodnoty tagu do formulare pro soubor
var tag,s:string;
begin
  if(CwgForm_lFileFile.ItemIndex>=0) then tag:=CwgForm_lFileFile.Items[CwgForm_lFileFile.ItemIndex]
  else tag:='';
  //vynulovat vsechny hodnoty
  CwgForm_eFileNick.text:='';  CwgForm_eFileGuid.text:='';
  CwgForm_eFileVerze.text:=''; CwgForm_eFileTyp.text:='';
  CwgForm_eFileUrl.text:='';
  CwgForm_eFileBublNick.text:=''; CwgForm_eFileBublImg.text:='';
  CwgForm_eFileDat.Date:=Now();
  CwgForm_eFileTyp.Items:=CwgForm_eTyp.Items;
  //ted naplnit formular spravnymi hodnotami
  CwgForm_eFileNick.text:=Trim(fetch(tag,'(<'));
  tag:='<'+copy(tag,1,length(tag)-1);
  CwgForm_eFileVerze.text:=StructStringGetValue('VER',tag);
  CwgForm_eFileTyp.text:=StructStringGetValue('TYP',tag);
  CwgForm_eFileGuid.text:=StructStringGetValue('GUID',tag);
  CwgForm_eFileUrl.text:=StructStringGetValue('URL',tag);
  s:=StructStringGetValue('DAT',tag);
  if(s<>'') then begin
    CwgForm_eFileDat.Date:=DDMMRRRRToDate(s);
    CwgForm_eFileDat.Checked:=true;
  end
  else CwgForm_eFileDat.Checked:=false;
  CwgForm_eFileBublNick.text:=StructStringGetValue('TXT_NICK',tag);
  CwgForm_eFileBublImg.text:=StructStringGetValue('TXT_CWG',tag);
  bFileChangeCwg:=false;
  bFileChangeNick:=false;
  SetEnableButFile();
end;

procedure FormFileToTag; //vytvori tag z hodnot ve romulari, pri chybe vraci ''
var s,s1,tag:string;
    idx:integer;
begin
  s:=Trim(CwgForm_eFileNick.Text);
  tag:=Trim(fetch(s,'(<'));
  s:='';
  if(CwgForm_eFileTyp.Text<>'') then s:=s+'<TYP="'+Trim(CwgForm_eFileTyp.Text)+'"/>';
  if(CwgForm_eFileVerze.Text<>'') then s:=s+'<VER="'+Trim(CwgForm_eFileVerze.Text)+'"/>';
  if(CwgForm_eFileGuid.Text<>'') then s:=s+'<GUID="'+Trim(CwgForm_eFileGuid.Text)+'"/>';
  //datum jen pokud je zaskrtnuto
  if(CwgForm_eFileDat.Checked) then begin
    s1:=DateToInt(CwgForm_eFileDat.Date);
    s:=s+'<DAT="'+copy(s1,7,2)+'.'+copy(s1,5,2)+'.'+copy(s1,1,4)+'"/>';
  end;
  if(CwgForm_eFileBublNick.Text<>'') then s:=s+'<TXT_NICK="'+Trim(CwgForm_eFileBublNick.Text)+'"/>';
  if(CwgForm_eFileBublImg.Text<>'') then s:=s+'<TXT_CWG="'+Trim(CwgForm_eFileBublImg.Text)+'"/>';
  if(CwgForm_eFileUrl.Text<>'') then s:=s+'<URL="'+Trim(CwgForm_eFileUrl.Text)+'"/>';
  if(tag<>'') then begin
    idx:=CwgForm_lFileFile.ItemIndex;
    if(s<>'') then tag:=tag+' ('+s+')';
    //prepiseme hodnotu do aktualniho radku v listboxu
    if(idx>=0) then CwgForm_lFileFile.Items[idx]:=tag
    else idx:=CwgForm_lFileFile.Items.Add(tag);
    CwgForm_lFileFile.ItemIndex:=idx;
    bFileChangeCwg:=false;
    bFileChangeNick:=false;
  end;
  bFileChangeList:=true;
  SetEnableButFile();
end;

procedure GetFileAlterCwg; //nacte data ze souboru s alternativnim seznamem CWG
var i:integer;
begin
  if(FileExists(sFileAlternative)) then CwgForm_lFileFile.Items.LoadFromFile(sFileAlternative)
  else CwgForm_lFileFile.Items.Clear();
  for i:=CwgForm_lFileFile.Items.Count-1 downto 0 do begin
    if(trim(CwgForm_lFileFile.Items[i])='') then CwgForm_lFileFile.Items.Delete(i);
  end;
  bFileChangeList:=false;
  if(CwgForm_lFileFile.Items.Count>0) then CwgForm_lFileFile.ItemIndex:=0;
  SetEnableButFile();
end;

procedure SaveFileAlterCwg; //ulozi data do souboru s alternativnim seznamem CWG
var s:string;
    i:integer;
begin
  s:='';
  for i:=0 to CwgForm_lFileFile.Items.Count-1 do begin
    s:=s+CwgForm_lFileFile.Items[i]+CRLF;
  end;
  StringToFile(s,sFileAlternative);
  bFileChangeList:=false;
  SetEnableButFile();
end;

procedure butFileAddOnCLick(sender:TObject); //doplneni CWG do souboru
var i:integer;
begin
  if(CwgForm_lFileKat.ItemIndex>=0) then begin
    //pridame, jen pokud tam jeste neni
    i:=CwgForm_lFileFile.Items.IndexOf(CwgForm_lFileKat.Items[CwgForm_lFileKat.ItemIndex]);
    if(i<0) then i:=CwgForm_lFileFile.Items.Add(CwgForm_lFileKat.Items[CwgForm_lFileKat.ItemIndex]);
    if(i>=0) then CwgForm_lFileFile.ItemIndex:=i;
    bFileChangeList:=true;
  end;
  SetEnableButFile();
  TagToFormFile();
end;

procedure butFileDelOnCLick(sender:TObject); //vymazani CWG ze souboru
var i:integer;
begin
  i:=CwgForm_lFileFile.ItemIndex
  if(i>=0) then begin
    CwgForm_lFileFile.Items.Delete(i);
    if(i>=CwgForm_lFileFile.Items.Count-1) then i:=i-1
    else CwgForm_lFileFile.ItemIndex:=i;
    bFileChangeList:=true;
    SetEnableButFile();
    lChooseNameOnClick(CwgForm_lFileFile);
  end;
  TagToFormFile();
end;

procedure butFileSaveOnClick(sender:TObject); //ulozeni seznamu CWG do souboru
begin SaveFileAlterCwg();end;

procedure butFileZmenitOnClick(sender:TObject); //zmena vlastnosti zvoleneho CWG
begin
  FormFileToTag;
end;

procedure butFileNewOnClick(sender:TObject); //doplneni CWG do seznamu
begin
  CwgForm_lFileFile.ItemIndex:=-1;
  FormFileToTag;
end;

procedure lFileFileOnClick(sender:TObject);
begin
  lChooseNameOnClick(sender);   //zobrazime CWG, pokud je povolen nahled
  TagToFormFile;
end;

procedure lFileKatOnClick(sender:TObject);
begin
  lChooseNameOnClick(sender);   //zobrazime CWG, pokud je povolen nahled
  SetEnableButFile;
end;

procedure bFileViewOnClick(sender:TObject);
begin
  CwgForm_imgFileCwg.Visible:=CwgForm_bFileView.Checked;
  lChooseNameOnClick(CwgForm_lFileKat);
end;

procedure butFileKatOnClick(sender:TObject);
begin
  butChooseAktOnClick(nil);
  ReadKatalog(CwgForm_lFileKat,CwgForm_bFileView.Checked);
end;

procedure InitFormFile;
begin
  //formular pro alternativni seznam CWG v textovem souboru
  //implicitni nastaveni nahledu se dela v lib (jen pri spusteni makra)
  //CwgForm_lFileFile.Sorted:=true;
  //CwgForm_lFileFile.Duplicates:=dupIgnore;
  CwgForm_lFileFile.Clear;
  CwgForm_sFileName.Caption:=CwgForm_sFileName.Caption+'   '+sFileAlternative;
  bFileChangeList:=false;
  CwgForm_butFileKat.OnClick:=@butFileKatOnClick;
  CwgForm_lFileFile.OnDblClick:=@lFileFileOnClick;
  CwgForm_lFileFile.onClick:=@lFileFileOnClick;
  CwgForm_lFileKat.onClick:=@lFileKatOnClick;
  CwgForm_lFileKat.onDblClick:=@butFileAddOnClick;
  CwgForm_butFileAdd.onClick:=@butFileAddOnClick;
  CwgForm_butFileDel.onClick:=@butFileDelOnClick;
  CwgForm_butFileSave.onClick:=@butFileSaveOnClick;
  CwgForm_butFileNew.onClick:=@butFileNewOnClick;
  CwgForm_butFileZmenit.onClick:=@butFileZmenitOnClick;
  CwgForm_bFileView.onClick:=@bFileViewOnClick;
  //zmeny
  CwgForm_eFileNick.onChange:=@OnFileChange;
  CwgForm_eFileVerze.onChange:=@OnFileChange;
  CwgForm_eFileDat.onChange:=@OnFileChange;
  CwgForm_eFileTyp.onChange:=@OnFileChange;
  CwgForm_eFileBublNick.onChange:=@OnFileChange;
  CwgForm_eFileGuid.onChange:=@OnFileChange;
  CwgForm_eFileBublImg.onChange:=@OnFileChange;
  CwgForm_eFileUrl.onChange:=@OnFileChange;
  GetFileAlterCwg();
  TagToFormFile();
  bFileViewOnClick(nil);
end;
