{
  funkce pro inicializaci a hlavni obsluhu (includovany jako posledni soubor)
}

procedure InitForm;
begin
  if(sDirOffline='') then begin     //jeste nebyla inicializace provedena
    //napred inicializujeme cesty k souborum
    sDirOffline:=RelToAbsPath(DIR_OFFLINE,GEOGET_SCRIPTDIR+'\'+INSTALL_DIR);
    ForceDirectories(sDirOffline);
    sFileKatalog:=RelToAbsFilename(FILE_KATALOG,sDirOffline);
    sFileAlternative:=RelToAbsFilename(FILE_ALTERNATIVE,GEOGET_SCRIPTDIR+'\'+INSTALL_DIR);
    sFileExport:=RelToAbsFilename(FILE_EXPORT,GEOGET_SCRIPTDIR+'\'+INSTALL_DIR);

    fFormToTag:=@FormToTag;
    fSetEnableButFile:=@SetEnableButFile;
    //fSetEnableBut:=@SetEnableBut;
    InitFormTag;
    InitFormFind;
    InitFormFile;
    InitFormCtlg;
    CwgCtlg_bChooseView.Checked:=(CWG_PREVIEW='1');
    CwgForm_bFileView.Checked:=(CWG_PREVIEW='1');
  end;
end;

procedure ZobrazDialog;
var i:integer;
begin
  i:=0;
  while(i<>2) do begin
    i:=2; //aby se to tu pri chybe ukoncilo ...
    //ShowMessage('Start zobrazeni dialogu, aktCache='+IntToStr(aktCache));
    i:=CwgForm.ShowModal(); //zobrazi dialog s nastavenou aktivni strankou
    //ShowMessage('RRRR Navratova hodnota z dialogu: '+IntToStr(i));
    if(i<4) then begin // dialog pro hledani je ukoncen hodnotou 4 nebo 5
      if(i>0) then aktCache:=aktCache+1;
      if(i<0) then aktCache:=aktCache-1;
      if(i<>2) then GetListForCache();
    end;
    if(i=4) then begin // zobrazi k editaci kes pridanou vyhledanim
      ClearEditForm();
      SetActiveTab('TabTag');    //prepneme na zobrazeni stranky s editaci tagu
      GetListForCache();
    end;
    if(i=5) then begin // jen prida kese k seznamu pro editaci
    end;
  end;
end;

function CwgEditInfo(idx:integer): integer;
begin
  iCwg:=-1;
  bUser:=0;
  bChangeList:=0;                           //zadna zmena v nastaveni CWG u kese
  bChangeCwg:=0;
  bChangeNick:=0;
  InitForm();
  SetActiveTab('TabTag');    //prepneme na zobrazeni stranky s editaci tagu
  //nacteme zpracovavanou kes
  if((idx>=nCwgCaches) or (idx<0)) then begin
    ShowMessage('Index kee mimo rozsah.');
    Result:=-1;
  end
  else begin
    aktCache:=idx;
    GetListForCache();                        //nacte seznam CWG ke zvolene kesi
    if(bGgc=1) then begin  //priznak volani z ggc/ggp
      CwgForm_butStop.Caption:='Cancel';
      CwgForm_butNext.Visible:=false;
      CwgForm_butSaveNext.Visible:=false;
    end;
    //ShowMessage('HHHHHH Volam InitForm()');
    //vyvolame formular a zpracujeme ukonceni
    //  3 - ignorovane zmeny, dalsi kes (cancel)
    //  2 - zavreno krizkem, nasilim ukonceny dialog
    //  2 - zavreno tlacitkem, ukoncit zpracovani ostatnich oznacenych kesi
    //  1 - ulozene zmeny a skocit na dalsi kes
    bUser:=1;
    aktCache:=0;
    ZobrazDialog();
  end;
end;

procedure CwgFind; //hledani kesi podle CWG
begin
  SetActiveTab('TabFind');    //prepneme na zobrazeni stranky s hledanim
  //InitForm();
  CwgForm_eFindCwg.text:='';
  aktCache:=0;
  ZobrazDialog();
end;

procedure LibInit;
begin
  fCwgEditInfo:=@CwgEditInfo;
  nCwgCaches:=0;
  sCwgCaches:=TStringList.Create();
  sCwgCaches.Sorted:=true;
  sCwgCaches.Duplicates:=dupIgnore;
  geo:=TGeo.Create();
  InitForm();
  //nastavime zobrazeni prvni Tab (nasledujici po tabu Definice), pokud neni zobrazena
  SetActiveTab('TabTag');
  //CwgForm_TabFile.TabVisible:=false; //zmizime zalozku, ktera se zatim nepouziva
  //naplnime seznam pro alternativni zadavani CWG textovym souborem
  ReadKatalog(CwgForm_lFileKat,false);
end;
