{
  funkce pro obsluhu zalozky pracujici s TAGem v databazi
}
function GetCwgList: string;
var tab: TSqliteTable;
    counter,max,i,j,n: integer;
    s,s1,cwg,dotaz,ver,sType:string;
    a,aOut:TStringList;
    x,y:extended;
begin
  sFileAlternative:=RelToAbsFilename(FILE_ALTERNATIVE,GEOGET_SCRIPTDIR+'\'+INSTALL_DIR);
  a:=TStringList.Create();
  a.sorted:=true;
  //a.duplicates:=dupIgnore; //ignorovat duplicity?
  a.duplicates:=dupAccept; //akceptovat duplnicitni CWG
  aOut:=TStringList.Create();
  //nacteme obsah alternativniho seznamu CWG
  if(FileExists(sFileAlternative)) then a.LoadFromFile(sFileAlternative);
  for i:=a.Count-1 downto 0 do begin //oriznout jmena a vypustit prazdne radky
    s:=Trim(a[i]);
    if(s<>a[i]) then begin
      a.Delete(i);
      if(s<>'') then a.Add(s);
    end;
  end;
  //if(FileExists(sFileAlternative)) then aOut.LoadFromFile(sFileAlternative);
  //ShowMessage('DDDDD pocet CWG z '+sFileAlternative+': '+IntToStr(a.Count));
  Result:='';
  dotaz:=' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv '
     +'  WHERE gtc.value="'+TAG_CWG+'" and gtv.key=gt.ptrvalue and '
     +'  gt.id=gc.id and gtc.key=gt.ptrkat ORDER BY gtv.value';
  Counter:=0;
  GeoBusyStart;
  GeoBusyCaption('Generovani seznamu CWG');
  GeoBusyKind('Nacteni seznamu ...');
  //zjistime pocet pro BusyDialog
  max:=Geoget_DB.GetTableValue('SELECT count(gtv.value) '+dotaz);
  Counter:=0;
  tab:=Geoget_DB.GetTable('SELECT gtv.value '+dotaz,false);
  i:=0;
  n:=1;
  try
    while not tab.eof do begin
      if GeoBusyTest then Break;  //preruseno uzivatelem
      Counter:=Counter+1;
      GeoBusyProgress(Counter, max);
      s:=tab.FieldAsString(0);  // nactem CWG a info o nem
      //odrizneme cast se zavorkou a zjistime typ, pokud je a je jiny
      ver:=RegexReplace('(.*<VER=")([0-9]*)("\s*/\s*>.*)$',s,'$2',true);
      if(s=ver) then ver:='';
      s:=tab.FieldAsString(0);  // nactem CWG a info o nem
      cwg:=fetch(s,'(<');
      s1:=RegexExtract('TYP="(.*?)"\s*/\s*>',s);
      if(RegexFind('="*\s*CWG\s*"\s*/\s*>', s1)) then s1:='';
      //Result:=Result+cwg+': "'+s1+'"'+CRLF;
      if(s1='') then begin
        s:=UtfToAnsi(cwg);
        if(ver<>'') then s:=s+' (verze '+ver+')';
        a.Add(s);
      end;
      tab.next;                   // skok na dalsi
    end;
  finally tab.free;
  end;
  //vytvorime vystupni seznam, k CWG pridame pocet stejnych, pokud je >1
  n:=1;
  if(a.Count>0) then begin
    s:=a[0];
    aOut.Add(s);
    for i:=1 to a.Count-1 do begin
      if(UtfToGps(AnsiToUtf(s))=UtfToGps(AnsiToUtf(a[i]))) then begin   //porovnani bez ohledu na velikost pismen a cestinu
        n:=n+1;
        aOut[aOut.Count-1]:=a[i]+' ['+IntToStr(n)+']';
      end
      else begin
        s:=a[i];
        aOut.Add(s);
        n:=1;
      end;
    end;
  end;
  sType:=FILE_OUTPUT_TYPE;
  if(sType='') then begin
    if(RegexFind('(?i).gpx$',FILE_EXPORT)) then sType:='GPX_POI'
    else if(RegexFind('(?i).csv$',FILE_EXPORT)) then sType:='CSV'
    else sType:='TXT';
  end;
  //vystup spojenych seznamu do stringu
  if(sType='GPX_POI') then   begin
    s1:=UpperCase(GXP_POI_RANGE_CHARS);
    if(not RefPointGet(CWG_POI_POSITION,x,y)) then begin y:=14.0; x:=50.0; end;
    n:=0;
    s:='';
    Result:='';
    ver:=''; //prvni ulozeny znak
    for i:=0 to aOut.Count do begin
      if(i<aOut.Count) then begin
        j:=pos(UpperCase(copy(aOut[i],1,1)),s1);
        if(j>0) then begin
          s1:=ReplaceString(s1,copy(s1,j,1),''); //vymazeme znak, aby se na nem uz nedelil do dalsiho WPT
        end;
      end
      else j:=-1;
      if(i=aOut.Count) or (j>0) then begin
        if(s<>'') then begin //pridame zacatek a konec wpt a ulozime do Result
          Result:=Result
            + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
              +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
            +'  <name>'+CDATA(POI_NAME+' '+copy(ver,1,1)+'-'+copy(ver,2,1))+'</name>'+CRLF
            +'  <cmt></cmt>'+CRLF
            +'  <desc>'+CDATA(AnsiToUtf(s))+'</desc>'+CRLF
            +'</wpt>'+CRLF
          ver:='';
          s:='';
        end;
      end;
      if(i<aOut.Count) then begin
        //zapamatujeme si prvni a posledni pocatecni znak jmena CWG v tomto WPT
        ver:=copy(ver,1,1)+UpperCase(copy(aOut[i],1,1));
        s:=s+IntToStr(i+1)+'. '+aOut[i]+'<br />'+CRLF;
      end;
    end;
    s:=AnsiToUtf(s);
    Result:='<?xml version="1.0" encoding="utf-8" standalone="no" ?>'+CRLF
      +'<gpx '+CRLF
      +'  creator="'+GeoGet_Version+', CwgList '+VERSION+'"'+CRLF
      +'  version="1.1"'+CRLF
      +'  xmlns="http://www.topografix.com/GPX/1/1"'+CRLF
      +'  xmlns:gpxx="http://www.garmin.com/xmlschemas/GpxExtensions/v3"'+CRLF
      +'  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+CRLF
      +'  xsi:schemaLocation="http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">'
      +CRLF+CRLF+Result+
{
      + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
      +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
      +'  <name>'+CDATA(POI_NAME)+'</name>'+CRLF
      +'  <cmt></cmt>'+CRLF
      +'  <desc>'+CDATA(s)+'</desc>'+CRLF
      +'</wpt>'+CRLF
}
      +CRLF
      +'</gpx>'+CRLF;
  end
  else begin
    if(CSV_INCNUM='VERTICAL') then begin
      max:=round((aOut.Count+StrToInt(CSV_COLS)-1)/StrToInt(CSV_COLS)); //pocet radku
      for i:=0 to max-1 do begin
        for n:=0 to StrToInt(CSV_COLS)-1 do begin
          if(n*max+i<aOut.Count) then Result:=Result+'"'+IntToStr(n*max+i+1)+'. '+aOut[n*max+i]+'"';
          if(n<StrToInt(CSV_COLS)) then Result:=Result+'; ';
        end;
        Result:=Result+CRLF;
      end;
    end
    else begin    // pro CSV_INCNUM='VERTICAL'
      n:=0;
      for i:=0 to aOut.Count-1 do begin
        n:=n+1;
        Result:=Result+'"'+IntToStr(i+1)+'. '+aOut[i]+'"';
        if(n>=StrToInt(CSV_COLS)) then begin n:=0; Result:=Result+CRLF; end
        else Result:=Result+';';
      end;
    end;
  end;
end;

procedure SetEnableBut;
begin
  CwgForm_butSave.Enabled:=((nCwgCaches>0) and (bChangeList>0));
  CwgForm_butSaveNext.Enabled:=((nCwgCaches>0) and (bChangeList>0));
  CwgForm_butAdd.Enabled:=((nCwgCaches>0) and (bChangeNick>0));
  CwgForm_butNext.Enabled:=(nCwgCaches>1);
  CwgForm_butPrev.Enabled:=(nCwgCaches>1);
  CwgForm_butDel.Enabled:=((nCwgCaches>0) and (iCwg>-1));
  CwgForm_butSaveCwg.Enabled:=((nCwgCaches>0) and (iCwg>-1) and (bChangeCwg=1));
  CwgForm_sNumCwg.Caption:=IntToStr(iCwg+1)+' / '+IntToStr(CwgForm_lCwg.Items.Count);
  CwgForm_sNumCache.Caption:=IntToStr(aktCache+1)+' / '+IntToStr(nCwgCaches);
end;

procedure TagToForm; //naplni hodnoty tagu do formulare
var tag,s:string;
begin
  if(iCwg>=0) then tag:=CwgForm_lCwg.Items[iCwg]
  else tag:='';
  //vynulovat vsechny hodnoty
  CwgForm_eNick.text:='';  CwgForm_eGuid.text:='';
  CwgForm_eVerze.text:=''; CwgForm_eTyp.text:=''; CwgForm_eId.text:=''; CwgForm_eUrl.text:='';
  CwgForm_eIdBubl.text:=''; CwgForm_eDatBubl.text:=''; CwgForm_eNickBubl.text:='';
  CwgForm_eCwgBubl.text:='';
  if(geo.Found<=1) then CwgForm_eDat.Date:=Now()
  else CwgForm_eDat.Date:=geo.Found;
  CwgForm_eDat.Checked:=false;  //musi byt az po nastaveni data, jinak je zaskrtnuto
  //ted naplnit formular spravnymi hodnotami
  CwgForm_ID.caption:=geo.ID+' - '+UtfToAnsi(geo.Name);
  //ShowMessage('FFFFFF tag='+tag);
  CwgForm_eNick.text:=Trim(fetch(tag,'(<'));
  tag:='<'+copy(tag,1,length(tag)-1);
  CwgForm_eVerze.text:=StructStringGetValue('VER',tag);
  CwgForm_eTyp.text:=StructStringGetValue('TYP',tag);
  CwgForm_eId.text:=StructStringGetValue('ID',tag);
  CwgForm_eGuid.text:=StructStringGetValue('GUID',tag);
  CwgForm_eIdBubl.text:=StructStringGetValue('TXT_ID',tag);
  CwgForm_eUrl.text:=StructStringGetValue('URL',tag);
  s:=StructStringGetValue('DAT',tag);
  if(s<>'') then begin
    CwgForm_eDat.Date:=DDMMRRRRToDate(s);
    CwgForm_eDat.Checked:=true;
  end;
  CwgForm_eDatBubl.text:=StructStringGetValue('TXT_DAT',tag);
  CwgForm_eNickBubl.text:=StructStringGetValue('TXT_NICK',tag);
  CwgForm_eCwgBubl.text:=StructStringGetValue('TXT_CWG',tag);
  bChangeCwg:=0;
  bChangeNick:=0;
end;

procedure IsSavedCwg;   //pokud nejsou ulozene zmeny, opta se na jejich ulozeni
begin                   //pripadne je ulozi
  if(bChangeCwg>0) then begin
    if(6=MessBox('Ve vybranm CWG jsou neuloen zmny. Pokud'+CRLF+
                 'nebudou pepsny do seznamu CWG, budou ztraceny.'+CRLF+CRLF+
                 'Pepsat ped pokraovnm hodnoty CWG do seznamu?'
                 ,'Neuloen zmny vybranho CWG', 4 {tj. Ano/ne, odpoved 6=Ano})) then
      fFormToTag();//odpoved je Ano, ulozime zmeny
  end;
  bChangeCwg:=0;
  bChangeNick:=0;
  SetEnableBut();
end;

procedure lCwgOnClick(sender:TObject); //zmena aktualniho CWG
begin
  //test neulozenych hodnot posledniho CWG
  IsSavedCwg();
  bUser:=0;
  iCwg:=CwgForm_lCwg.ItemIndex;
  TagToForm();
  SetEnableBut();
  bUser:=1;
end;

procedure GetTypesCwg;
var tab: TSqliteTable;
    a:TStringList;
    s:string;
begin
  //nacteme seznam vsech typu CWG, ktere jsou zatim v databazi
  CwgForm_eTyp.Clear(); //vymazat vsechny polozky
  a:=TStringList.Create(); //pripravit seznam, aby nebral stejne polozky
  a.sorted:=true;
  a.duplicates:=dupIgnore;

  tab:=Geoget_DB.GetTable('SELECT gtv.value FROM geotagvalue gtv where gtv.value LIKE "%<TYP=%"',false);
  try
    while not tab.eof do begin
      if GeoBusyTest then Break;  //preruseno uzivatelem
      s:=UtfToAnsi(tab.FieldAsString(0));  // nactem CWG a info o nem
      //s1:=RegexExtract('<TYP="(.*?)"\s*/\s*>',s);
      //s1:=ReplaceString(s1,'<TYP=','');
      //s1:=ReplaceString(s1,'>','');
      //a.Add(s1);
      a.Add(StructStringGetValue('TYP',s));
      tab.next;                   // skok na dalsi
    end;
  finally tab.free;
  end;
  CwgForm_eTyp.Items:=a;
end;

procedure ClearEditForm;
begin
  iCwg:=-1;
  bUser:=0;
  bChangeList:=0;                           //zadna zmena v nastaveni CWG u kese
  bChangeCwg:=0;
  bChangeNick:=0;
  aktCache:=0;
  CwgForm_eNick.text:=''; CwgForm_eGuid.text:='';
  CwgForm_eVerze.text:=''; CwgForm_eTyp.text:=''; CwgForm_eId.text:=''; CwgForm_eUrl.text:='';
  CwgForm_eIdBubl.text:=''; CwgForm_eDatBubl.text:=''; CwgForm_eNickBubl.text:='';
  CwgForm_eCwgBubl.text:='';
  CwgForm_eDat.Checked:=false;  //musi byt az po nastaveni data, jinak je zaskrtnuto
  CwgForm_ID.caption:='';
  CwgForm_eNick.text:='';
  GetTypesCwg();
end;

procedure FormToTag; //vytvori tag z hodnot ve romulari, pri chybe vraci ''
var s,s1,tag:string;
begin
  s:=Trim(CwgForm_eNick.Text);
  //odpareme pripadne (<VER=...)
  tag:=Trim(fetch(s,'(<'));
  s:='';
  if(CwgForm_eTyp.Text<>'') then s:=s+'<TYP="'+Trim(CwgForm_eTyp.Text)+'"/>';
  if(CwgForm_eVerze.Text<>'') then s:=s+'<VER="'+Trim(CwgForm_eVerze.Text)+'"/>';
  if(CwgForm_eId.Text<>'') then s:=s+'<ID="'+Trim(CwgForm_eId.Text)+'"/>';
  if(CwgForm_eGuid.Text<>'') then s:=s+'<GUID="'+Trim(CwgForm_eGuid.Text)+'"/>';
  //datum jen pokud je zaskrtnuto
  if(CwgForm_eDat.Checked) then begin
    s1:=DateToInt(CwgForm_eDat.Date);
    s:=s+'<DAT="'+copy(s1,7,2)+'.'+copy(s1,5,2)+'.'+copy(s1,1,4)+'"/>';
  end;
  if(CwgForm_eNickBubl.Text<>'') then s:=s+'<TXT_NICK="'+Trim(CwgForm_eNickBubl.Text)+'"/>';
  if(CwgForm_eDatBubl.Text<>'') then s:=s+'<TXT_DAT="'+Trim(CwgForm_eDatBubl.Text)+'"/>';
  if(CwgForm_eIdBubl.Text<>'') then s:=s+'<TXT_ID="'+Trim(CwgForm_eIdBubl.Text)+'"/>';
  if(CwgForm_eCwgBubl.Text<>'') then s:=s+'<TXT_CWG="'+Trim(CwgForm_eCwgBubl.Text)+'"/>';
  if(CwgForm_eUrl.Text<>'') then s:=s+'<URL="'+Trim(CwgForm_eUrl.Text)+'"/>';
  if(tag<>'') then begin
    if(s<>'') then tag:=tag+' ('+s+')';
    //prepiseme hodnotu do aktualniho radku v listboxu
    if(iCwg>=0) then CwgForm_lCwg.Items[iCwg]:=tag
    else iCwg:=CwgForm_lCwg.Items.Add(tag);
    //ShowMessage('ERR: Nelze uloit zmny v nastaven CWG');
    bChangeCwg:=0;
    bChangeNick:=0;
  end;
  bChangeList:=1;
  SetEnableBut();
end;

procedure GetListForCache;  //nacte seznam CWG ke zvolene kesi a zobrazi 1. CWG z nej
var aCwgList:TStringList;
    i:integer;
begin
  CwgForm_lCwg.Clear();
  //ShowMessage('FFFFFF aktCache='+IntToStr(aktCache)+', nCwgCaches='+IntToStr(nCwgCaches));
  if((aktCache<=nCwgCaches) and (aktCache>=0)) then begin
    if(aktCache<0) then aktCache:=nCwgCaches-1;
    if(aktCache>=nCwgCaches) then aktCache:=0;
    if(aktCache<nCwgCaches) then begin
      //ShowMessage('CCCCC aktCache='+IntToStr(aktCache)+', '+sCwgCaches[aktCache]);
      geo.LoadByGc(sCwgCaches[aktCache]);
      aCwgList:=TStringList.create;
      aCwgList.text:=geo.TagValues(TAG_CWG);
      try
        for i:=0 to aCwgList.Count-1 do begin
          CwgForm_lCwg.Items.Add(UtfToAnsi(aCwgList[i]));
        end;
      finally
        aCwgList.free;
      end;
      //ShowMessage('XXXXX 3');
      //nastavi prvni CWG jako vybrane a z tagu zobrazi informace o nem
      if(CwgForm_lCwg.Items.Count<=0) then iCwg:=-1
      else begin
        iCwg:=0;
        CwgForm_lCwg.ItemIndex:=0;
      end;
      lCwgOnClick(nil);
    end;
  end
  else begin
    ClearEditForm();
  end;
end;

procedure OnChange(sender:TObject);
begin
  if(bUser=1) then begin //jen pokud mohla byt akce vyvolana uzivatelem
    bChangeCwg:=1;
    SetEnableBut();
  end;
end;

procedure SaveListForCache; //ulozi nacteny seznam CWG do databaze
var i:integer;
begin
  IsSavedCwg();
  if(bChangeList=1) then begin
    GeoGet_DB.Start(TRANSACTION_NAME,'');        //zahajit transakci
    geo.TagClear(TAG_CWG);                //napred vymazat vsechny CWG teto kese
    //ulozit vsechny CWG v seznamu CwgForm_lCwg.Items
    for i:=0 to CwgForm_lCwg.Items.Count-1 do begin
      //ShowMessage('UUUUUU - Pridavam TAG CWG: '+CwgForm_lCwg.Items[i]);
      geo.TagAdd(TAG_CWG,AnsiToUtf(CwgForm_lCwg.Items[i]));
    end;
    GeoGet_DB.Commit(TRANSACTION_NAME);          //ukoncit transakci
    geo.ListAdd();//promitneme zmenu v seznamu zobrazenych kesi
  end;
  bChangeList:=0;
  SetEnableBut();
end;

procedure butSaveOnClick(sender:TObject);
begin
  SaveListForCache();
end;

procedure IsSavedList;   //pokud nejsou ulozene zmeny, opta se na jejich ulozeni
begin                //pripadne je ulozi
  IsSavedCwg();
  if(bChangeList>0) then begin
    if(6=MessBox('V seznamu CWG jsou neuloen zmny. Pokud'+CRLF+
                 'nebudou uloeny do databze, budou ztraceny.'+CRLF+CRLF+
                 'Uloit je ped pokraovnm?'
                 ,'Neuloen zmny v seznamu CWG', 4 {tj. Ano/ne, odpoved 6=Ano}))
      then butSaveOnClick(nil);//odpoved je Ano, ulozime zmeny
  end;
  bChangeList:=0;
  SetEnableBut();
end;

procedure butNextOnClick(sender:TObject);
begin
  IsSavedList();
end;

procedure butSaveNextOnClick(sender:TObject);
begin
  butSaveOnClick(nil);
end;

procedure butStopOnClick(sender:TObject);
begin
  IsSavedList();
end;

procedure butDelOnClick(sender:TObject);
begin
  if(6=MessBox('Opravdu zruit zznam o CWG?','Potvrzen akce',4 {tj. Ano/ne, odpoved 6=Ano}))
    then CwgForm_lCwg.Items.Delete(iCwg);//odpoved je Ano, ulozime zmeny
  iCwg:=iCwg-1;
  if((iCwg<0) and (CwgForm_lCwg.Items.Count>0)) then iCwg:=0;
  CwgForm_lCwg.ItemIndex:=iCwg;
  bChangeList:=1;
  TagToForm();
end;

procedure butSaveCwgOnClick(sender:TObject);
begin
  FormToTag();
end;

procedure butAddOnClick(sender:TObject);
var s,dotaz:string;
    i:integer;
begin
  s:=Trim(CwgForm_eNick.text);
  if(s<>'') then begin
    //zkontrolujeme, zda CWG jiz nekde neni
    dotaz:='SELECT count(gc.id) FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv '+CRLF
     +'  WHERE gtc.value="'+TAG_CWG+'" and gtv.key=gt.ptrvalue and '+CRLF
     +'  (upper(gtv.value) LIKE '''+AnsiToUtf(s)+' %'' or upper(gtv.value)=upper('''+AnsiToUtf(s)+''')) and '+CRLF
     +'  gt.id=gc.id and gtc.key=gt.ptrkat ORDER BY gtv.value';
    //ShowMessage('VVVV dotaz '+dotaz);
    i:=Geoget_DB.GetTableValue(dotaz);
    //ShowMessage('VVVV pocet CWG se jmenem '+s+CRLF+IntToStr(i));
    if(i<>0) then begin
      i:=MessBox('CWG "'+s+'" ji jednou v TAGu je u jin kee.'+CRLF
      +'Opravdu CWG pidat?','Opakovan pidn CWG',4);
      if(i=6) then i:=0;
    end;
    if(i=0) then begin
      iCwg:=CwgForm_lCwg.Items.Add(s);
      CwgForm_lCwg.ItemIndex:=iCwg;
      onChange(nil);
      FormToTag();
      butSaveCwgOnClick(nil);
    end;
  end;
end;

procedure eNickOnChange(sender:TObject);
begin
  bChangeNick:=1;
  OnChange(nil);
end;

procedure InitFormTag;
begin
  fOnChange:=@OnChange;
  CwgForm_lCwg.onClick:=@lCwgOnClick;       //vymazani aktualniho CWG ze seznamu kese
  //implicitni nastaveni nahledu se dela v lib (jen pri spusteni makra)
  //nastavime obsluhu tlacitek a poli
  CwgForm_butDel.onClick:=@butDelOnClick;   //vymazani aktualniho CWG ze seznamu kese
  CwgForm_butAdd.onCLick:=@butAddOnClick;   //pridani CWG z formulare do seznamu kese
  CwgForm_butSave.onClick:=@butSaveOnClick; //ulozi seznam CWG do databaze
  CwgForm_butNext.onClick:=@butNextOnClick; //preskocit na dalsi oznacenou kes
  CwgForm_butSaveNext.onClick:=@butSaveNextOnClick; //ulozit a preskocit na dalsi oznacenou kes
  CwgForm_butStop.onClick:=@butStopOnClick; //prerusit zpracovani seznamu oznacenych kesi
  CwgForm_butSaveCwg.onClick:=@butSaveCwgOnClick;
  CwgForm_butCwgChoose.onClick:=@butCwgChooseOnClick;
  //zmeny ve vsech editacnich polich
  CwgForm_eNick.onChange:=@eNickOnChange;
  CwgForm_eGuid.onChange:=@OnChange;
  CwgForm_eNickBubl.onChange:=@OnChange;
  CwgForm_eVerze.onChange:=@OnChange;
  CwgForm_eTyp.onChange:=@OnChange;
  CwgForm_eDat.onChange:=@OnChange;
  CwgForm_eDatBubl.onChange:=@OnChange;
  CwgForm_eId.onChange:=@OnChange;
  CwgForm_eUrl.onChange:=@OnChange;
  CwgForm_eIdBubl.onChange:=@OnChange;
  CwgForm_eCwgBubl.onChange:=@OnChange;
  //obsluha klavesy ESC pro zruseni dialogu s vyberem CWG z katalogu
  //CwgForm_butCwgChoose.onKeyDown:=@ChooseCwgOnKeyDown;
  //vynulovani vsech hodnot ve vsech TABech
  ClearEditForm();
  CwgForm_eFindCwg.text:='';
  aktCache:=-1;
  SetEnableBut();
end;
